/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

#ifndef mozilla_ServoStyleConsts_h
#define mozilla_ServoStyleConsts_h

/* Generated with cbindgen:0.8.7 */

/* DO NOT MODIFY THIS MANUALLY! This file was generated using cbindgen.
 * To generate this file:
 *   1. Get the latest cbindgen using `cargo install --force cbindgen`
 *      a. Alternatively, you can clone `https://github.com/eqrion/cbindgen` and use a tagged release
 *   2. Run `rustup run nightly cbindgen toolkit/library/rust/ --lockfile Cargo.lock --crate style -o layout/style/ServoStyleConsts.h`
 */
#include "nsCoord.h"
#include "Units.h"
#include "mozilla/gfx/Types.h"
class nsAtom;
namespace mozilla {
  class WritingMode;
  enum HalfCorner : uint8_t;
  enum LogicalSide : uint8_t;
  namespace css {
    struct URLValue;
  }

  // Work-around weird cbindgen renaming.
  typedef css::URLValue StyleURLValue;
  typedef nsAtom StylensAtom;
}


#include <cstdarg>
#include <cstdint>
#include <cstdlib>
#include <new>

namespace mozilla {

/// Whether to allow negative lengths or not.
enum class StyleAllowedNumericType : uint8_t {
  /// Allow all kind of numeric values.
  All,
  /// Allow only non-negative numeric values.
  NonNegative,
  /// Allow only numeric values greater or equal to 1.0.
  AtLeastOne,
};

/// The value for the `appearance` property.
/// https://developer.mozilla.org/en-US/docs/Web/CSS/-moz-appearance
enum class StyleAppearance : uint8_t {
  /// No appearance at all.
  None,
  /// A typical dialog button.
  Button,
  /// Various arrows that go in buttons
  ButtonArrowDown,
  ButtonArrowNext,
  ButtonArrowPrevious,
  ButtonArrowUp,
  /// A rectangular button that contains complex content
  /// like images (e.g. HTML <button> elements)
  ButtonBevel,
  /// The focus outline box inside of a button.
  ButtonFocus,
  /// The caret of a text area
  Caret,
  /// A dual toolbar button (e.g., a Back button with a dropdown)
  Dualbutton,
  /// A groupbox.
  Groupbox,
  /// A inner-spin button.
  InnerSpinButton,
  /// List boxes.
  Listbox,
  /// A listbox item.
  Listitem,
  /// Menu Bar background
  Menubar,
  /// <menu> and <menuitem> appearances
  Menuitem,
  Checkmenuitem,
  Radiomenuitem,
  /// For text on non-iconic menuitems only
  Menuitemtext,
  /// A dropdown list.
  Menulist,
  /// The dropdown button(s) that open up a dropdown list.
  MenulistButton,
  /// The text part of a dropdown list, to left of button.
  MenulistText,
  /// An editable textfield with a dropdown list (a combobox).
  MenulistTextfield,
  /// Menu Popup background.
  Menupopup,
  /// menu checkbox/radio appearances
  Menucheckbox,
  Menuradio,
  Menuseparator,
  Menuarrow,
  /// An image in the menu gutter, like in bookmarks or history.
  Menuimage,
  /// A horizontal meter bar.
  Meter,
  /// The meter bar's meter indicator.
  Meterchunk,
  /// The "arrowed" part of the dropdown button that open up a dropdown list.
  MozMenulistButton,
  /// For HTML's <input type=number>
  NumberInput,
  /// A horizontal progress bar.
  ProgressBar,
  /// The progress bar's progress indicator
  Progresschunk,
  /// A vertical progress bar.
  ProgressbarVertical,
  /// A checkbox element.
  Checkbox,
  /// A radio element within a radio group.
  Radio,
  /// A generic container that always repaints on state changes. This is a
  /// hack to make XUL checkboxes and radio buttons work.
  CheckboxContainer,
  RadioContainer,
  /// The label part of a checkbox or radio button, used for painting a focus
  /// outline.
  CheckboxLabel,
  RadioLabel,
  /// nsRangeFrame and its subparts
  Range,
  RangeThumb,
  /// The resizer background area in a status bar for the resizer widget in
  /// the corner of a window.
  Resizerpanel,
  /// The resizer itself.
  Resizer,
  /// A slider.
  ScaleHorizontal,
  ScaleVertical,
  /// A slider's thumb.
  ScalethumbHorizontal,
  ScalethumbVertical,
  /// If the platform supports it, the left/right chunks of the slider thumb.
  Scalethumbstart,
  Scalethumbend,
  /// The ticks for a slider.
  Scalethumbtick,
  /// A scrollbar.
  Scrollbar,
  /// A small scrollbar.
  ScrollbarSmall,
  /// The scrollbar slider
  ScrollbarHorizontal,
  ScrollbarVertical,
  /// A scrollbar button (up/down/left/right).
  /// Keep these in order (some code casts these values to `int` in order to
  /// compare them against each other).
  ScrollbarbuttonUp,
  ScrollbarbuttonDown,
  ScrollbarbuttonLeft,
  ScrollbarbuttonRight,
  /// The scrollbar thumb.
  ScrollbarthumbHorizontal,
  ScrollbarthumbVertical,
  /// The scrollbar track.
  ScrollbartrackHorizontal,
  ScrollbartrackVertical,
  /// The scroll corner
  Scrollcorner,
  /// A searchfield.
  Searchfield,
  /// A separator.  Can be horizontal or vertical.
  Separator,
  /// A spin control (up/down control for time/date pickers).
  Spinner,
  /// The up button of a spin control.
  SpinnerUpbutton,
  /// The down button of a spin control.
  SpinnerDownbutton,
  /// The textfield of a spin control
  SpinnerTextfield,
  /// A splitter.  Can be horizontal or vertical.
  Splitter,
  /// A status bar in a main application window.
  Statusbar,
  /// A single pane of a status bar.
  Statusbarpanel,
  /// A single tab in a tab widget.
  Tab,
  /// A single pane (inside the tabpanels container).
  Tabpanel,
  /// The tab panels container.
  Tabpanels,
  /// The tabs scroll arrows (left/right).
  TabScrollArrowBack,
  TabScrollArrowForward,
  /// A multi-line text field, e.g. HTML <textarea>.
  Textarea,
  /// A single-line text field, e.g. HTML <input type=text>.
  Textfield,
  /// A toolbar in an application window.
  Toolbar,
  /// A single toolbar button (with no associated dropdown).
  Toolbarbutton,
  /// The dropdown portion of a toolbar button
  ToolbarbuttonDropdown,
  /// The gripper for a toolbar.
  Toolbargripper,
  /// The toolbox that contains the toolbars.
  Toolbox,
  /// A tooltip.
  Tooltip,
  /// A listbox or tree widget header
  Treeheader,
  /// An individual header cell
  Treeheadercell,
  /// The sort arrow for a header.
  Treeheadersortarrow,
  /// A tree item.
  Treeitem,
  /// A tree widget branch line
  Treeline,
  /// A tree widget twisty.
  Treetwisty,
  /// Open tree widget twisty.
  Treetwistyopen,
  /// A tree widget.
  Treeview,
  /// Window and dialog backgrounds.
  Window,
  Dialog,
  /// Vista Rebars.
  MozWinCommunicationsToolbox,
  MozWinMediaToolbox,
  MozWinBrowsertabbarToolbox,
  /// Vista glass.
  MozWinGlass,
  MozWinBorderlessGlass,
  /// -moz-apperance style used in setting proper glass margins.
  MozWinExcludeGlass,
  /// Titlebar elements on the Mac.
  MozMacFullscreenButton,
  /// Mac help button.
  MozMacHelpButton,
  /// Windows themed window frame elements.
  MozWindowButtonBox,
  MozWindowButtonBoxMaximized,
  MozWindowButtonClose,
  MozWindowButtonMaximize,
  MozWindowButtonMinimize,
  MozWindowButtonRestore,
  MozWindowFrameBottom,
  MozWindowFrameLeft,
  MozWindowFrameRight,
  MozWindowTitlebar,
  MozWindowTitlebarMaximized,
  MozGtkInfoBar,
  MozMacActiveSourceListSelection,
  MozMacDisclosureButtonClosed,
  MozMacDisclosureButtonOpen,
  MozMacSourceList,
  MozMacSourceListSelection,
  MozMacVibrancyDark,
  MozMacVibrancyLight,
  MozMacVibrantTitlebarDark,
  MozMacVibrantTitlebarLight,
  /// A non-disappearing scrollbar.
  ScrollbarNonDisappearing,
  /// A themed focus outline (for outline:auto).
  /// This isn't exposed to CSS at all, just here for convenience.
  FocusOutline,
  /// A dummy variant that should be last to let the GTK widget do hackery.
  Count,
};

/// A specified value for a single side of a `border-style` property.
/// The order here corresponds to the integer values from the border conflict
/// resolution rules in CSS 2.1 § 17.6.2.1. Higher values override lower values.
enum class StyleBorderStyle : uint8_t {
  Hidden,
  None,
  Inset,
  Groove,
  Outset,
  Ridge,
  Dotted,
  Dashed,
  Solid,
  Double,
};

/// A kind of break between two boxes.
/// https://drafts.csswg.org/css-break/#break-between
enum class StyleBreakBetween : uint8_t {
  Always,
  Auto,
  Page,
  Avoid,
  Left,
  Right,
};

/// A kind of break within a box.
/// https://drafts.csswg.org/css-break/#break-within
enum class StyleBreakWithin : uint8_t {
  Auto,
  Avoid,
};

/// The keywords allowed in the Cursor property.
/// https://drafts.csswg.org/css-ui-4/#propdef-cursor
enum class StyleCursorKind : uint8_t {
  None,
  Default,
  Pointer,
  ContextMenu,
  Help,
  Progress,
  Wait,
  Cell,
  Crosshair,
  Text,
  VerticalText,
  Alias,
  Copy,
  Move,
  NoDrop,
  NotAllowed,
  Grab,
  Grabbing,
  EResize,
  NResize,
  NeResize,
  NwResize,
  SResize,
  SeResize,
  SwResize,
  WResize,
  EwResize,
  NsResize,
  NeswResize,
  NwseResize,
  ColResize,
  RowResize,
  AllScroll,
  ZoomIn,
  ZoomOut,
  Auto,
  MozGrab,
  MozGrabbing,
  MozZoomIn,
  MozZoomOut,
};

/// Defines an element’s display type, which consists of
/// the two basic qualities of how an element generates boxes
/// <https://drafts.csswg.org/css-display/#propdef-display>
/// NOTE(emilio): Order is important in Gecko!
/// If you change it, make sure to take a look at the
/// FrameConstructionDataByDisplay stuff (both the XUL and non-XUL version), and
/// ensure it's still correct!
enum class StyleDisplay : uint8_t {
  None = 0,
  Block,
  FlowRoot,
  Inline,
  InlineBlock,
  ListItem,
  Table,
  InlineTable,
  TableRowGroup,
  TableColumn,
  TableColumnGroup,
  TableHeaderGroup,
  TableFooterGroup,
  TableRow,
  TableCell,
  TableCaption,
  Flex,
  InlineFlex,
  Grid,
  InlineGrid,
  Ruby,
  RubyBase,
  RubyBaseContainer,
  RubyText,
  RubyTextContainer,
  Contents,
  WebkitBox,
  WebkitInlineBox,
  MozBox,
  MozInlineBox,
  MozGrid,
  MozInlineGrid,
  MozGridGroup,
  MozGridLine,
  MozStack,
  MozInlineStack,
  MozDeck,
  MozGroupbox,
  MozPopup,
};

/// Values for the display-mode media feature.
enum class StyleDisplayMode : uint8_t {
  Browser = 0,
  MinimalUi,
  Standalone,
  Fullscreen,
};

/// A type for possible values for min- and max- flavors of width, height,
/// block-size, and inline-size.
enum class StyleExtremumLength : uint8_t {
  MaxContent,
  MinContent,
  MozFitContent,
  MozAvailable,
};

enum class StyleFillRule : uint8_t {
  Nonzero,
  Evenodd,
};

/// A computed value for the `float` property.
enum class StyleFloat : uint8_t {
  Left,
  Right,
  None,
};

/// A font-display value for a @font-face rule.
/// The font-display descriptor determines how a font face is displayed based
/// on whether and when it is downloaded and ready to use.
enum class StyleFontDisplay : uint8_t {
  Auto,
  Block,
  Swap,
  Fallback,
  Optional,
};

/// The path command absolute type.
enum class StyleIsAbsolute : uint8_t {
  Yes,
  No,
};

/// The value for the `overflow-x` / `overflow-y` properties.
enum class StyleOverflow : uint8_t {
  Visible,
  Hidden,
  Scroll,
  Auto,
  MozHiddenUnscrollable,
};

enum class StyleOverflowAnchor : uint8_t {
  Auto,
  None,
};

enum class StyleOverflowClipBox : uint8_t {
  PaddingBox,
  ContentBox,
};

/// Values for the `overflow-wrap` property.
enum class StyleOverflowWrap : uint8_t {
  Normal,
  BreakWord,
  Anywhere,
};

enum class StyleOverscrollBehavior : uint8_t {
  Auto,
  Contain,
  None,
};

/// Values for the prefers-color-scheme media feature.
enum class StylePrefersColorScheme : uint8_t {
  Light,
  Dark,
  NoPreference,
};

/// A computed value for the `resize` property.
enum class StyleResize : uint8_t {
  None,
  Both,
  Horizontal,
  Vertical,
};

/// Specified value of scroll-snap-align keyword value.
enum class StyleScrollSnapAlignKeyword : uint8_t {
  None,
  Start,
  End,
  Center,
};

enum class StyleScrollSnapType : uint8_t {
  None,
  Mandatory,
  Proximity,
};

enum class StyleStepPosition : uint8_t {
  JumpStart,
  JumpEnd,
  JumpNone,
  JumpBoth,
  Start,
  End,
};

enum class StyleTimingKeyword : uint8_t {
  Linear,
  Ease,
  EaseIn,
  EaseOut,
  EaseInOut,
};

/// The specified value for the `user-select` property.
/// https://drafts.csswg.org/css-ui-4/#propdef-user-select
enum class StyleUserSelect : uint8_t {
  Auto,
  Text,
  None,
  /// Force selection of all children.
  All,
};

/// Values for the `word-break` property.
enum class StyleWordBreak : uint8_t {
  Normal,
  BreakAll,
  KeepAll,
  /// The break-word value, needed for compat.
  /// Specifying `word-break: break-word` makes `overflow-wrap` behave as
  /// `anywhere`, and `word-break` behave like `normal`.
  BreakWord,
};

/// <https://drafts.csswg.org/css-ui/#propdef-outline-style>
struct StyleOutlineStyle {
  enum class Tag : uint8_t {
    /// auto
    Auto,
    /// <border-style>
    BorderStyle,
  };

  struct StyleBorderStyle_Body {
    StyleBorderStyle _0;

    bool operator==(const StyleBorderStyle_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleBorderStyle_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleBorderStyle_Body border_style;
  };

  static StyleOutlineStyle Auto() {
    StyleOutlineStyle result;
    result.tag = Tag::Auto;
    return result;
  }

  static StyleOutlineStyle BorderStyle(const StyleBorderStyle &a0) {
    StyleOutlineStyle result;
    ::new (&result.border_style._0) (StyleBorderStyle)(a0);
    result.tag = Tag::BorderStyle;
    return result;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  bool IsBorderStyle() const {
    return tag == Tag::BorderStyle;
  }

  const StyleBorderStyle& AsBorderStyle() const {
    MOZ_ASSERT(IsBorderStyle());
    return border_style._0;
  }

  bool operator==(const StyleOutlineStyle& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::BorderStyle: return border_style == other.border_style;
      default: return true;
    }
  }

  bool operator!=(const StyleOutlineStyle& other) const {
    return !(*this == other);
  }
};

/// The computed representation of the above, so that
/// Gecko can read them easily.
struct StyleComputedFontStretchRange {
  float _0;
  float _1;

  bool operator==(const StyleComputedFontStretchRange& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleComputedFontStretchRange& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// The computed representation of the above, with angles in degrees, so that
/// Gecko can read them easily.
union StyleComputedFontStyleDescriptor {
  enum class Tag : uint8_t {
    Normal,
    Italic,
    Oblique,
  };

  struct Oblique_Body {
    Tag tag;
    float _0;
    float _1;

    bool operator==(const Oblique_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const Oblique_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct {
    Tag tag;
  };
  Oblique_Body oblique;

  static StyleComputedFontStyleDescriptor Normal() {
    StyleComputedFontStyleDescriptor result;
    result.tag = Tag::Normal;
    return result;
  }

  static StyleComputedFontStyleDescriptor Italic() {
    StyleComputedFontStyleDescriptor result;
    result.tag = Tag::Italic;
    return result;
  }

  static StyleComputedFontStyleDescriptor Oblique(const float &a0,
                                                  const float &a1) {
    StyleComputedFontStyleDescriptor result;
    ::new (&result.oblique._0) (float)(a0);
    ::new (&result.oblique._1) (float)(a1);
    result.tag = Tag::Oblique;
    return result;
  }

  bool IsNormal() const {
    return tag == Tag::Normal;
  }

  bool IsItalic() const {
    return tag == Tag::Italic;
  }

  bool IsOblique() const {
    return tag == Tag::Oblique;
  }

  const Oblique_Body& AsOblique() const {
    MOZ_ASSERT(IsOblique());
    return oblique;
  }

  bool operator==(const StyleComputedFontStyleDescriptor& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Oblique: return oblique == other.oblique;
      default: return true;
    }
  }

  bool operator!=(const StyleComputedFontStyleDescriptor& other) const {
    return !(*this == other);
  }
};

/// The computed representation of the above so Gecko can read them easily.
/// This one is needed because cbindgen doesn't know how to generate
/// specified::Number.
struct StyleComputedFontWeightRange {
  float _0;
  float _1;

  bool operator==(const StyleComputedFontWeightRange& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleComputedFontWeightRange& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// A CSS integer value.
using StyleCSSInteger = int32_t;

/// A `<integer>` value.
using StyleInteger = StyleCSSInteger;

/// A CSS float value.
using StyleCSSFloat = float;

/// A `<number>` value.
using StyleNumber = StyleCSSFloat;

/// A generic easing function.
template<typename Integer, typename Number>
struct StyleTimingFunction {
  enum class Tag : uint8_t {
    /// `linear | ease | ease-in | ease-out | ease-in-out`
    Keyword,
    /// `cubic-bezier(<number>, <number>, <number>, <number>)`
    CubicBezier,
    /// `step-start | step-end | steps(<integer>, [ <step-position> ]?)`
    /// `<step-position> = jump-start | jump-end | jump-none | jump-both | start | end`
    Steps,
  };

  struct StyleKeyword_Body {
    StyleTimingKeyword _0;

    bool operator==(const StyleKeyword_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleKeyword_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleCubicBezier_Body {
    Number x1;
    Number y1;
    Number x2;
    Number y2;

    bool operator==(const StyleCubicBezier_Body& other) const {
      return x1 == other.x1 &&
             y1 == other.y1 &&
             x2 == other.x2 &&
             y2 == other.y2;
    }
    bool operator!=(const StyleCubicBezier_Body& other) const {
      return x1 != other.x1 ||
             y1 != other.y1 ||
             x2 != other.x2 ||
             y2 != other.y2;
    }
  };

  struct StyleSteps_Body {
    Integer _0;
    StyleStepPosition _1;

    bool operator==(const StyleSteps_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleSteps_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  Tag tag;
  union {
    StyleKeyword_Body keyword;
    StyleCubicBezier_Body cubic_bezier;
    StyleSteps_Body steps;
  };

  static StyleTimingFunction Keyword(const StyleTimingKeyword &a0) {
    StyleTimingFunction result;
    ::new (&result.keyword._0) (StyleTimingKeyword)(a0);
    result.tag = Tag::Keyword;
    return result;
  }

  static StyleTimingFunction CubicBezier(const Number &aX1,
                                         const Number &aY1,
                                         const Number &aX2,
                                         const Number &aY2) {
    StyleTimingFunction result;
    ::new (&result.cubic_bezier.x1) (Number)(aX1);
    ::new (&result.cubic_bezier.y1) (Number)(aY1);
    ::new (&result.cubic_bezier.x2) (Number)(aX2);
    ::new (&result.cubic_bezier.y2) (Number)(aY2);
    result.tag = Tag::CubicBezier;
    return result;
  }

  static StyleTimingFunction Steps(const Integer &a0,
                                   const StyleStepPosition &a1) {
    StyleTimingFunction result;
    ::new (&result.steps._0) (Integer)(a0);
    ::new (&result.steps._1) (StyleStepPosition)(a1);
    result.tag = Tag::Steps;
    return result;
  }

  bool IsKeyword() const {
    return tag == Tag::Keyword;
  }

  bool IsCubicBezier() const {
    return tag == Tag::CubicBezier;
  }

  bool IsSteps() const {
    return tag == Tag::Steps;
  }

  const StyleTimingKeyword& AsKeyword() const {
    MOZ_ASSERT(IsKeyword());
    return keyword._0;
  }

  const StyleCubicBezier_Body& AsCubicBezier() const {
    MOZ_ASSERT(IsCubicBezier());
    return cubic_bezier;
  }

  const StyleSteps_Body& AsSteps() const {
    MOZ_ASSERT(IsSteps());
    return steps;
  }

  bool operator==(const StyleTimingFunction& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Keyword: return keyword == other.keyword;
      case Tag::CubicBezier: return cubic_bezier == other.cubic_bezier;
      case Tag::Steps: return steps == other.steps;
      default: return true;
    }
  }

  bool operator!=(const StyleTimingFunction& other) const {
    return !(*this == other);
  }
};

/// A computed timing function.
using StyleComputedTimingFunction = StyleTimingFunction<StyleInteger, StyleNumber>;

/// A POD representation for Gecko. All pointers here are non-owned and as such
/// can't outlive the rule they came from, but we can't enforce that via C++.
/// All the strings are of course utf8.
union StyleFontFaceSourceListComponent {
  enum class Tag : uint8_t {
    Url,
    Local,
    FormatHint,
  };

  struct Url_Body {
    Tag tag;
    const StyleURLValue *_0;

    bool operator==(const Url_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const Url_Body& other) const {
      return _0 != other._0;
    }
  };

  struct Local_Body {
    Tag tag;
    StylensAtom *_0;

    bool operator==(const Local_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const Local_Body& other) const {
      return _0 != other._0;
    }
  };

  struct FormatHint_Body {
    Tag tag;
    uintptr_t length;
    const uint8_t *utf8_bytes;

    bool operator==(const FormatHint_Body& other) const {
      return length == other.length &&
             utf8_bytes == other.utf8_bytes;
    }
    bool operator!=(const FormatHint_Body& other) const {
      return length != other.length ||
             utf8_bytes != other.utf8_bytes;
    }
  };

  struct {
    Tag tag;
  };
  Url_Body url;
  Local_Body local;
  FormatHint_Body format_hint;

  static StyleFontFaceSourceListComponent Url(const StyleURLValue *const &a0) {
    StyleFontFaceSourceListComponent result;
    ::new (&result.url._0) (const StyleURLValue*)(a0);
    result.tag = Tag::Url;
    return result;
  }

  static StyleFontFaceSourceListComponent Local(StylensAtom *const &a0) {
    StyleFontFaceSourceListComponent result;
    ::new (&result.local._0) (StylensAtom*)(a0);
    result.tag = Tag::Local;
    return result;
  }

  static StyleFontFaceSourceListComponent FormatHint(const uintptr_t &aLength,
                                                     const uint8_t *const &aUtf8Bytes) {
    StyleFontFaceSourceListComponent result;
    ::new (&result.format_hint.length) (uintptr_t)(aLength);
    ::new (&result.format_hint.utf8_bytes) (const uint8_t*)(aUtf8Bytes);
    result.tag = Tag::FormatHint;
    return result;
  }

  bool IsUrl() const {
    return tag == Tag::Url;
  }

  bool IsLocal() const {
    return tag == Tag::Local;
  }

  bool IsFormatHint() const {
    return tag == Tag::FormatHint;
  }

  const StyleURLValue*const & AsUrl() const {
    MOZ_ASSERT(IsUrl());
    return url._0;
  }

  StylensAtom*const & AsLocal() const {
    MOZ_ASSERT(IsLocal());
    return local._0;
  }

  const FormatHint_Body& AsFormatHint() const {
    MOZ_ASSERT(IsFormatHint());
    return format_hint;
  }

  bool operator==(const StyleFontFaceSourceListComponent& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Url: return url == other.url;
      case Tag::Local: return local == other.local;
      case Tag::FormatHint: return format_hint == other.format_hint;
      default: return true;
    }
  }

  bool operator!=(const StyleFontFaceSourceListComponent& other) const {
    return !(*this == other);
  }
};

/// font-language-override can only have a single three-letter
/// OpenType "language system" tag, so we should be able to compute
/// it and store it as a 32-bit integer
/// (see http://www.microsoft.com/typography/otspec/languagetags.htm).
struct StyleFontLanguageOverride {
  uint32_t _0;

  bool operator==(const StyleFontLanguageOverride& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleFontLanguageOverride& other) const {
    return _0 != other._0;
  }
};

/// The path coord type.
struct StyleCoordPair {
  StyleCSSFloat _0;
  StyleCSSFloat _1;

  bool operator==(const StyleCoordPair& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleCoordPair& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// The EllipticalArc flag type.
struct StyleArcFlag {
  bool _0;

  bool operator==(const StyleArcFlag& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleArcFlag& other) const {
    return _0 != other._0;
  }
};

/// The SVG path command.
/// The fields of these commands are self-explanatory, so we skip the documents.
/// Note: the index of the control points, e.g. control1, control2, are mapping to the control
/// points of the Bézier curve in the spec.
/// https://www.w3.org/TR/SVG11/paths.html#PathData
struct StylePathCommand {
  enum class Tag : uint8_t {
    /// The unknown type.
    /// https://www.w3.org/TR/SVG/paths.html#__svg__SVGPathSeg__PATHSEG_UNKNOWN
    Unknown,
    /// The "moveto" command.
    MoveTo,
    /// The "lineto" command.
    LineTo,
    /// The horizontal "lineto" command.
    HorizontalLineTo,
    /// The vertical "lineto" command.
    VerticalLineTo,
    /// The cubic Bézier curve command.
    CurveTo,
    /// The smooth curve command.
    SmoothCurveTo,
    /// The quadratic Bézier curve command.
    QuadBezierCurveTo,
    /// The smooth quadratic Bézier curve command.
    SmoothQuadBezierCurveTo,
    /// The elliptical arc curve command.
    EllipticalArc,
    /// The "closepath" command.
    ClosePath,
  };

  struct StyleMoveTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleMoveTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleMoveTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleLineTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleLineTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleLineTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleHorizontalLineTo_Body {
    StyleCSSFloat x;
    StyleIsAbsolute absolute;

    bool operator==(const StyleHorizontalLineTo_Body& other) const {
      return x == other.x &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleHorizontalLineTo_Body& other) const {
      return x != other.x ||
             absolute != other.absolute;
    }
  };

  struct StyleVerticalLineTo_Body {
    StyleCSSFloat y;
    StyleIsAbsolute absolute;

    bool operator==(const StyleVerticalLineTo_Body& other) const {
      return y == other.y &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleVerticalLineTo_Body& other) const {
      return y != other.y ||
             absolute != other.absolute;
    }
  };

  struct StyleCurveTo_Body {
    StyleCoordPair control1;
    StyleCoordPair control2;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleCurveTo_Body& other) const {
      return control1 == other.control1 &&
             control2 == other.control2 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleCurveTo_Body& other) const {
      return control1 != other.control1 ||
             control2 != other.control2 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleSmoothCurveTo_Body {
    StyleCoordPair control2;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleSmoothCurveTo_Body& other) const {
      return control2 == other.control2 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleSmoothCurveTo_Body& other) const {
      return control2 != other.control2 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleQuadBezierCurveTo_Body {
    StyleCoordPair control1;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleQuadBezierCurveTo_Body& other) const {
      return control1 == other.control1 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleQuadBezierCurveTo_Body& other) const {
      return control1 != other.control1 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleSmoothQuadBezierCurveTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleSmoothQuadBezierCurveTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleSmoothQuadBezierCurveTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleEllipticalArc_Body {
    StyleCSSFloat rx;
    StyleCSSFloat ry;
    StyleCSSFloat angle;
    StyleArcFlag large_arc_flag;
    StyleArcFlag sweep_flag;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleEllipticalArc_Body& other) const {
      return rx == other.rx &&
             ry == other.ry &&
             angle == other.angle &&
             large_arc_flag == other.large_arc_flag &&
             sweep_flag == other.sweep_flag &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleEllipticalArc_Body& other) const {
      return rx != other.rx ||
             ry != other.ry ||
             angle != other.angle ||
             large_arc_flag != other.large_arc_flag ||
             sweep_flag != other.sweep_flag ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  Tag tag;
  union {
    StyleMoveTo_Body move_to;
    StyleLineTo_Body line_to;
    StyleHorizontalLineTo_Body horizontal_line_to;
    StyleVerticalLineTo_Body vertical_line_to;
    StyleCurveTo_Body curve_to;
    StyleSmoothCurveTo_Body smooth_curve_to;
    StyleQuadBezierCurveTo_Body quad_bezier_curve_to;
    StyleSmoothQuadBezierCurveTo_Body smooth_quad_bezier_curve_to;
    StyleEllipticalArc_Body elliptical_arc;
  };

  static StylePathCommand Unknown() {
    StylePathCommand result;
    result.tag = Tag::Unknown;
    return result;
  }

  static StylePathCommand MoveTo(const StyleCoordPair &aPoint,
                                 const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.move_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.move_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::MoveTo;
    return result;
  }

  static StylePathCommand LineTo(const StyleCoordPair &aPoint,
                                 const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.line_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.line_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::LineTo;
    return result;
  }

  static StylePathCommand HorizontalLineTo(const StyleCSSFloat &aX,
                                           const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.horizontal_line_to.x) (StyleCSSFloat)(aX);
    ::new (&result.horizontal_line_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::HorizontalLineTo;
    return result;
  }

  static StylePathCommand VerticalLineTo(const StyleCSSFloat &aY,
                                         const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.vertical_line_to.y) (StyleCSSFloat)(aY);
    ::new (&result.vertical_line_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::VerticalLineTo;
    return result;
  }

  static StylePathCommand CurveTo(const StyleCoordPair &aControl1,
                                  const StyleCoordPair &aControl2,
                                  const StyleCoordPair &aPoint,
                                  const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.curve_to.control1) (StyleCoordPair)(aControl1);
    ::new (&result.curve_to.control2) (StyleCoordPair)(aControl2);
    ::new (&result.curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::CurveTo;
    return result;
  }

  static StylePathCommand SmoothCurveTo(const StyleCoordPair &aControl2,
                                        const StyleCoordPair &aPoint,
                                        const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.smooth_curve_to.control2) (StyleCoordPair)(aControl2);
    ::new (&result.smooth_curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.smooth_curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::SmoothCurveTo;
    return result;
  }

  static StylePathCommand QuadBezierCurveTo(const StyleCoordPair &aControl1,
                                            const StyleCoordPair &aPoint,
                                            const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.quad_bezier_curve_to.control1) (StyleCoordPair)(aControl1);
    ::new (&result.quad_bezier_curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.quad_bezier_curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::QuadBezierCurveTo;
    return result;
  }

  static StylePathCommand SmoothQuadBezierCurveTo(const StyleCoordPair &aPoint,
                                                  const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.smooth_quad_bezier_curve_to.point) (StyleCoordPair)(aPoint);
    ::new (&result.smooth_quad_bezier_curve_to.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::SmoothQuadBezierCurveTo;
    return result;
  }

  static StylePathCommand EllipticalArc(const StyleCSSFloat &aRx,
                                        const StyleCSSFloat &aRy,
                                        const StyleCSSFloat &aAngle,
                                        const StyleArcFlag &aLargeArcFlag,
                                        const StyleArcFlag &aSweepFlag,
                                        const StyleCoordPair &aPoint,
                                        const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    ::new (&result.elliptical_arc.rx) (StyleCSSFloat)(aRx);
    ::new (&result.elliptical_arc.ry) (StyleCSSFloat)(aRy);
    ::new (&result.elliptical_arc.angle) (StyleCSSFloat)(aAngle);
    ::new (&result.elliptical_arc.large_arc_flag) (StyleArcFlag)(aLargeArcFlag);
    ::new (&result.elliptical_arc.sweep_flag) (StyleArcFlag)(aSweepFlag);
    ::new (&result.elliptical_arc.point) (StyleCoordPair)(aPoint);
    ::new (&result.elliptical_arc.absolute) (StyleIsAbsolute)(aAbsolute);
    result.tag = Tag::EllipticalArc;
    return result;
  }

  static StylePathCommand ClosePath() {
    StylePathCommand result;
    result.tag = Tag::ClosePath;
    return result;
  }

  bool IsUnknown() const {
    return tag == Tag::Unknown;
  }

  bool IsMoveTo() const {
    return tag == Tag::MoveTo;
  }

  bool IsLineTo() const {
    return tag == Tag::LineTo;
  }

  bool IsHorizontalLineTo() const {
    return tag == Tag::HorizontalLineTo;
  }

  bool IsVerticalLineTo() const {
    return tag == Tag::VerticalLineTo;
  }

  bool IsCurveTo() const {
    return tag == Tag::CurveTo;
  }

  bool IsSmoothCurveTo() const {
    return tag == Tag::SmoothCurveTo;
  }

  bool IsQuadBezierCurveTo() const {
    return tag == Tag::QuadBezierCurveTo;
  }

  bool IsSmoothQuadBezierCurveTo() const {
    return tag == Tag::SmoothQuadBezierCurveTo;
  }

  bool IsEllipticalArc() const {
    return tag == Tag::EllipticalArc;
  }

  bool IsClosePath() const {
    return tag == Tag::ClosePath;
  }

  const StyleMoveTo_Body& AsMoveTo() const {
    MOZ_ASSERT(IsMoveTo());
    return move_to;
  }

  const StyleLineTo_Body& AsLineTo() const {
    MOZ_ASSERT(IsLineTo());
    return line_to;
  }

  const StyleHorizontalLineTo_Body& AsHorizontalLineTo() const {
    MOZ_ASSERT(IsHorizontalLineTo());
    return horizontal_line_to;
  }

  const StyleVerticalLineTo_Body& AsVerticalLineTo() const {
    MOZ_ASSERT(IsVerticalLineTo());
    return vertical_line_to;
  }

  const StyleCurveTo_Body& AsCurveTo() const {
    MOZ_ASSERT(IsCurveTo());
    return curve_to;
  }

  const StyleSmoothCurveTo_Body& AsSmoothCurveTo() const {
    MOZ_ASSERT(IsSmoothCurveTo());
    return smooth_curve_to;
  }

  const StyleQuadBezierCurveTo_Body& AsQuadBezierCurveTo() const {
    MOZ_ASSERT(IsQuadBezierCurveTo());
    return quad_bezier_curve_to;
  }

  const StyleSmoothQuadBezierCurveTo_Body& AsSmoothQuadBezierCurveTo() const {
    MOZ_ASSERT(IsSmoothQuadBezierCurveTo());
    return smooth_quad_bezier_curve_to;
  }

  const StyleEllipticalArc_Body& AsEllipticalArc() const {
    MOZ_ASSERT(IsEllipticalArc());
    return elliptical_arc;
  }

  bool operator==(const StylePathCommand& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::MoveTo: return move_to == other.move_to;
      case Tag::LineTo: return line_to == other.line_to;
      case Tag::HorizontalLineTo: return horizontal_line_to == other.horizontal_line_to;
      case Tag::VerticalLineTo: return vertical_line_to == other.vertical_line_to;
      case Tag::CurveTo: return curve_to == other.curve_to;
      case Tag::SmoothCurveTo: return smooth_curve_to == other.smooth_curve_to;
      case Tag::QuadBezierCurveTo: return quad_bezier_curve_to == other.quad_bezier_curve_to;
      case Tag::SmoothQuadBezierCurveTo: return smooth_quad_bezier_curve_to == other.smooth_quad_bezier_curve_to;
      case Tag::EllipticalArc: return elliptical_arc == other.elliptical_arc;
      default: return true;
    }
  }

  bool operator!=(const StylePathCommand& other) const {
    return !(*this == other);
  }
};

/// One contiguous range of code points.
/// Can not be empty. Can represent a single code point when start == end.
struct StyleUnicodeRange {
  /// Inclusive start of the range. In [0, end].
  uint32_t start;
  /// Inclusive end of the range. In [0, 0x10FFFF].
  uint32_t end;

  bool operator==(const StyleUnicodeRange& other) const {
    return start == other.start &&
           end == other.end;
  }
  bool operator!=(const StyleUnicodeRange& other) const {
    return start != other.start ||
           end != other.end;
  }
};

/// https://drafts.csswg.org/css-scroll-snap-1/#scroll-snap-align
struct StyleScrollSnapAlign {
  StyleScrollSnapAlignKeyword block;
  StyleScrollSnapAlignKeyword inline_;

  bool operator==(const StyleScrollSnapAlign& other) const {
    return block == other.block &&
           inline_ == other.inline_;
  }
  bool operator!=(const StyleScrollSnapAlign& other) const {
    return block != other.block ||
           inline_ != other.inline_;
  }
};

/// The computed `<length>` value.
struct StyleCSSPixelLength {
  StyleCSSFloat _0;

  bool operator==(const StyleCSSPixelLength& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleCSSPixelLength& other) const {
    return _0 != other._0;
  }
  inline nscoord ToAppUnits() const;
  inline bool IsZero() const;
};

/// An alias of computed `<length>` value.
using StyleLength = StyleCSSPixelLength;

/// A computed percentage.
struct StylePercentage {
  StyleCSSFloat _0;

  bool operator==(const StylePercentage& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StylePercentage& other) const {
    return _0 != other._0;
  }
};

/// A `<length-percentage>` value. This can be either a `<length>`, a
/// `<percentage>`, or a combination of both via `calc()`.
/// https://drafts.csswg.org/css-values-4/#typedef-length-percentage
struct StyleLengthPercentage {
  StyleLength length;
  StylePercentage percentage;
  StyleAllowedNumericType clamping_mode;
  /// Whether we specified a percentage or not.
  bool has_percentage;
  /// Whether this was from a calc() expression. This is needed because right
  /// now we don't treat calc() the same way as non-calc everywhere, but
  /// that's a bug in most cases.
  /// Please don't add new uses of this that aren't for converting to Gecko's
  /// representation, or to interpolate values.
  /// See https://github.com/w3c/csswg-drafts/issues/3482.
  bool was_calc;

  bool operator==(const StyleLengthPercentage& other) const {
    return length == other.length &&
           percentage == other.percentage &&
           clamping_mode == other.clamping_mode &&
           has_percentage == other.has_percentage &&
           was_calc == other.was_calc;
  }
  bool operator!=(const StyleLengthPercentage& other) const {
    return length != other.length ||
           percentage != other.percentage ||
           clamping_mode != other.clamping_mode ||
           has_percentage != other.has_percentage ||
           was_calc != other.was_calc;
  }
  // Defined in nsStyleCoord.h
  static constexpr inline StyleLengthPercentage Zero();
  static inline StyleLengthPercentage FromAppUnits(nscoord);
  static inline StyleLengthPercentage FromPixels(CSSCoord);
  static inline StyleLengthPercentage FromPercentage(float);
  inline CSSCoord LengthInCSSPixels() const;
  inline float Percentage() const;
  inline bool HasPercent() const;
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline bool HasLengthAndPercentage() const;
  inline float ToPercentage() const;
  inline bool IsDefinitelyZero() const;
  inline CSSCoord ResolveToCSSPixels(CSSCoord aPercentageBasisInCSSPixels) const;
  template<typename T> inline CSSCoord ResolveToCSSPixelsWith(T aPercentageGetter) const;
  template<typename T, typename U>
  inline nscoord Resolve(T aPercentageGetter, U aPercentRoundingFunction) const;
  template<typename T>
  inline nscoord Resolve(nscoord aPercentageBasis, T aPercentRoundingFunction) const;
  template<typename T> inline nscoord Resolve(T aPercentageGetter) const;
  inline nscoord Resolve(nscoord aPercentageBasis) const;
};

/// A computed value for the `letter-spacing` property.
using StyleLetterSpacing = StyleLength;

/// A wrapper of Non-negative values.
template<typename T>
using StyleNonNegative = T;

/// A wrapper of LengthPercentage, whose value must be >= 0.
using StyleNonNegativeLengthPercentage = StyleNonNegative<StyleLengthPercentage>;

/// A `<length-percentage> | auto` value.
template<typename LengthPercent>
struct StyleGenericLengthPercentageOrAuto {
  enum class Tag : uint8_t {
    LengthPercentage,
    Auto,
  };

  struct StyleLengthPercentage_Body {
    LengthPercent _0;

    bool operator==(const StyleLengthPercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLengthPercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLengthPercentage_Body length_percentage;
  };

  static StyleGenericLengthPercentageOrAuto LengthPercentage(const LengthPercent &a0) {
    StyleGenericLengthPercentageOrAuto result;
    ::new (&result.length_percentage._0) (LengthPercent)(a0);
    result.tag = Tag::LengthPercentage;
    return result;
  }

  static StyleGenericLengthPercentageOrAuto Auto() {
    StyleGenericLengthPercentageOrAuto result;
    result.tag = Tag::Auto;
    return result;
  }

  bool IsLengthPercentage() const {
    return tag == Tag::LengthPercentage;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  const LengthPercent& AsLengthPercentage() const {
    MOZ_ASSERT(IsLengthPercentage());
    return length_percentage._0;
  }

  bool operator==(const StyleGenericLengthPercentageOrAuto& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::LengthPercentage: return length_percentage == other.length_percentage;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericLengthPercentageOrAuto& other) const {
    return !(*this == other);
  }
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline float ToPercentage() const;
  inline bool HasPercent() const;
  inline bool HasLengthAndPercentage() const;
};

/// A computed type for `<length-percentage> | auto`.
using StyleLengthPercentageOrAuto = StyleGenericLengthPercentageOrAuto<StyleLengthPercentage>;

/// A wrapper of Number, but the value >= 0.
using StyleNonNegativeNumber = StyleNonNegative<StyleCSSFloat>;

/// A wrapper of Length, whose value must be >= 0.
using StyleNonNegativeLength = StyleNonNegative<StyleLength>;

/// A generic value for the `line-height` property.
template<typename N, typename L>
struct StyleGenericLineHeight {
  enum class Tag : uint8_t {
    /// `normal`
    Normal,
    /// `-moz-block-height`
    MozBlockHeight,
    /// `<number>`
    Number,
    /// `<length-percentage>`
    Length,
  };

  struct StyleNumber_Body {
    N _0;

    bool operator==(const StyleNumber_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleNumber_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleLength_Body {
    L _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleNumber_Body number;
    StyleLength_Body length;
  };

  static StyleGenericLineHeight Normal() {
    StyleGenericLineHeight result;
    result.tag = Tag::Normal;
    return result;
  }

  static StyleGenericLineHeight MozBlockHeight() {
    StyleGenericLineHeight result;
    result.tag = Tag::MozBlockHeight;
    return result;
  }

  static StyleGenericLineHeight Number(const N &a0) {
    StyleGenericLineHeight result;
    ::new (&result.number._0) (N)(a0);
    result.tag = Tag::Number;
    return result;
  }

  static StyleGenericLineHeight Length(const L &a0) {
    StyleGenericLineHeight result;
    ::new (&result.length._0) (L)(a0);
    result.tag = Tag::Length;
    return result;
  }

  bool IsNormal() const {
    return tag == Tag::Normal;
  }

  bool IsMozBlockHeight() const {
    return tag == Tag::MozBlockHeight;
  }

  bool IsNumber() const {
    return tag == Tag::Number;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  const N& AsNumber() const {
    MOZ_ASSERT(IsNumber());
    return number._0;
  }

  const L& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericLineHeight& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Number: return number == other.number;
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericLineHeight& other) const {
    return !(*this == other);
  }
};

/// A computed value for the `line-height` property.
using StyleLineHeight = StyleGenericLineHeight<StyleNonNegativeNumber, StyleNonNegativeLength>;

/// A wrapper of LengthPercentageOrAuto, whose value must be >= 0.
using StyleNonNegativeLengthPercentageOrAuto = StyleGenericLengthPercentageOrAuto<StyleNonNegativeLengthPercentage>;

/// A CSS value made of four components, where its `ToCss` impl will try to
/// serialize as few components as possible, like for example in `border-width`.
template<typename T>
struct StyleRect {
  T _0;
  T _1;
  T _2;
  T _3;

  bool operator==(const StyleRect& other) const {
    return _0 == other._0 &&
           _1 == other._1 &&
           _2 == other._2 &&
           _3 == other._3;
  }
  bool operator!=(const StyleRect& other) const {
    return _0 != other._0 ||
           _1 != other._1 ||
           _2 != other._2 ||
           _3 != other._3;
  }
  // Defined in nsStyleCoord.h
  template<typename Predicate> inline bool All(Predicate) const;
  template<typename Predicate> inline bool Any(Predicate) const;

  // Defined in WritingModes.h
  inline const T& Get(mozilla::Side) const;
  inline const T& Get(mozilla::WritingMode, mozilla::LogicalSide) const;
  inline const T& GetIStart(mozilla::WritingMode) const;
  inline const T& GetBStart(mozilla::WritingMode) const;
  inline const T& GetIEnd(mozilla::WritingMode) const;
  inline const T& GetBEnd(mozilla::WritingMode) const;
};

/// The value of an IntersectionObserver's rootMargin property.
/// Only bare px or percentage values are allowed. Other length units and
/// calc() values are not allowed.
/// <https://w3c.github.io/IntersectionObserver/#parse-a-root-margin>
using StyleIntersectionObserverRootMargin = StyleRect<StyleLengthPercentage>;

/// A generic value for the `width`, `height`, `min-width`, or `min-height` property.
/// Unlike `max-width` or `max-height` properties, a Size can be `auto`,
/// and cannot be `none`.
/// Note that it only accepts non-negative values.
template<typename LengthPercent>
struct StyleGenericSize {
  enum class Tag : uint8_t {
    LengthPercentage,
    Auto,
    ExtremumLength,
  };

  struct StyleLengthPercentage_Body {
    LengthPercent _0;

    bool operator==(const StyleLengthPercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLengthPercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleExtremumLength_Body {
    StyleExtremumLength _0;

    bool operator==(const StyleExtremumLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleExtremumLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLengthPercentage_Body length_percentage;
    StyleExtremumLength_Body extremum_length;
  };

  static StyleGenericSize LengthPercentage(const LengthPercent &a0) {
    StyleGenericSize result;
    ::new (&result.length_percentage._0) (LengthPercent)(a0);
    result.tag = Tag::LengthPercentage;
    return result;
  }

  static StyleGenericSize Auto() {
    StyleGenericSize result;
    result.tag = Tag::Auto;
    return result;
  }

  static StyleGenericSize ExtremumLength(const StyleExtremumLength &a0) {
    StyleGenericSize result;
    ::new (&result.extremum_length._0) (StyleExtremumLength)(a0);
    result.tag = Tag::ExtremumLength;
    return result;
  }

  bool IsLengthPercentage() const {
    return tag == Tag::LengthPercentage;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  bool IsExtremumLength() const {
    return tag == Tag::ExtremumLength;
  }

  const LengthPercent& AsLengthPercentage() const {
    MOZ_ASSERT(IsLengthPercentage());
    return length_percentage._0;
  }

  const StyleExtremumLength& AsExtremumLength() const {
    MOZ_ASSERT(IsExtremumLength());
    return extremum_length._0;
  }

  bool operator==(const StyleGenericSize& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::LengthPercentage: return length_percentage == other.length_percentage;
      case Tag::ExtremumLength: return extremum_length == other.extremum_length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericSize& other) const {
    return !(*this == other);
  }
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline float ToPercentage() const;
  inline bool HasPercent() const;
  inline bool HasLengthAndPercentage() const;
  inline bool BehavesLikeInitialValueOnBlockAxis() const;
};

/// A computed value for `min-width`, `min-height`, `width` or `height` property.
using StyleSize = StyleGenericSize<StyleNonNegativeLengthPercentage>;

/// A generic value for the `max-width` or `max-height` property.
template<typename LengthPercent>
struct StyleGenericMaxSize {
  enum class Tag : uint8_t {
    LengthPercentage,
    None,
    ExtremumLength,
  };

  struct StyleLengthPercentage_Body {
    LengthPercent _0;

    bool operator==(const StyleLengthPercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLengthPercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleExtremumLength_Body {
    StyleExtremumLength _0;

    bool operator==(const StyleExtremumLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleExtremumLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLengthPercentage_Body length_percentage;
    StyleExtremumLength_Body extremum_length;
  };

  static StyleGenericMaxSize LengthPercentage(const LengthPercent &a0) {
    StyleGenericMaxSize result;
    ::new (&result.length_percentage._0) (LengthPercent)(a0);
    result.tag = Tag::LengthPercentage;
    return result;
  }

  static StyleGenericMaxSize None() {
    StyleGenericMaxSize result;
    result.tag = Tag::None;
    return result;
  }

  static StyleGenericMaxSize ExtremumLength(const StyleExtremumLength &a0) {
    StyleGenericMaxSize result;
    ::new (&result.extremum_length._0) (StyleExtremumLength)(a0);
    result.tag = Tag::ExtremumLength;
    return result;
  }

  bool IsLengthPercentage() const {
    return tag == Tag::LengthPercentage;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  bool IsExtremumLength() const {
    return tag == Tag::ExtremumLength;
  }

  const LengthPercent& AsLengthPercentage() const {
    MOZ_ASSERT(IsLengthPercentage());
    return length_percentage._0;
  }

  const StyleExtremumLength& AsExtremumLength() const {
    MOZ_ASSERT(IsExtremumLength());
    return extremum_length._0;
  }

  bool operator==(const StyleGenericMaxSize& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::LengthPercentage: return length_percentage == other.length_percentage;
      case Tag::ExtremumLength: return extremum_length == other.extremum_length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericMaxSize& other) const {
    return !(*this == other);
  }
  inline bool ConvertsToLength() const;
  inline nscoord ToLength() const;
  inline bool ConvertsToPercentage() const;
  inline float ToPercentage() const;
  inline bool HasPercent() const;
  inline bool HasLengthAndPercentage() const;
  inline bool BehavesLikeInitialValueOnBlockAxis() const;
};

/// A computed value for `max-width` or `min-height` property.
using StyleMaxSize = StyleGenericMaxSize<StyleNonNegativeLengthPercentage>;

/// A generic value for the `flex-basis` property.
template<typename S>
struct StyleGenericFlexBasis {
  enum class Tag {
    /// `content`
    Content,
    /// `<width>`
    Size,
  };

  struct StyleSize_Body {
    S _0;

    bool operator==(const StyleSize_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleSize_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleSize_Body size;
  };

  static StyleGenericFlexBasis Content() {
    StyleGenericFlexBasis result;
    result.tag = Tag::Content;
    return result;
  }

  static StyleGenericFlexBasis Size(const S &a0) {
    StyleGenericFlexBasis result;
    ::new (&result.size._0) (S)(a0);
    result.tag = Tag::Size;
    return result;
  }

  bool IsContent() const {
    return tag == Tag::Content;
  }

  bool IsSize() const {
    return tag == Tag::Size;
  }

  const S& AsSize() const {
    MOZ_ASSERT(IsSize());
    return size._0;
  }

  bool operator==(const StyleGenericFlexBasis& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Size: return size == other.size;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericFlexBasis& other) const {
    return !(*this == other);
  }
  inline bool IsAuto() const;
};

/// A computed value for the `flex-basis` property.
using StyleFlexBasis = StyleGenericFlexBasis<StyleSize>;

/// The computed value of a CSS horizontal position.
using StyleHorizontalPosition = StyleLengthPercentage;

/// The computed value of a CSS vertical position.
using StyleVerticalPosition = StyleLengthPercentage;

/// A generic type for representing a CSS [position](https://drafts.csswg.org/css-values/#position).
template<typename H, typename V>
struct StyleGenericPosition {
  /// The horizontal component of position.
  H horizontal;
  /// The vertical component of position.
  V vertical;

  bool operator==(const StyleGenericPosition& other) const {
    return horizontal == other.horizontal &&
           vertical == other.vertical;
  }
  bool operator!=(const StyleGenericPosition& other) const {
    return horizontal != other.horizontal ||
           vertical != other.vertical;
  }
  inline bool DependsOnPositioningAreaSize() const;
  static inline StyleGenericPosition FromPercentage(float);
};

/// The computed value of a CSS `<position>`
using StylePosition = StyleGenericPosition<StyleHorizontalPosition, StyleVerticalPosition>;

/// A generic value for the `background-size` property.
template<typename LengthPercent>
struct StyleGenericBackgroundSize {
  enum class Tag : uint8_t {
    /// `<width> <height>`
    ExplicitSize,
    /// `cover`
    Cover,
    /// `contain`
    Contain,
  };

  struct StyleExplicitSize_Body {
    /// Explicit width.
    StyleGenericLengthPercentageOrAuto<LengthPercent> width;
    /// Explicit height.
    /// NOTE(emilio): We should probably simplify all these in case `width`
    /// and `height` are the same, but all other browsers agree on only
    /// special-casing `auto`.
    StyleGenericLengthPercentageOrAuto<LengthPercent> height;

    bool operator==(const StyleExplicitSize_Body& other) const {
      return width == other.width &&
             height == other.height;
    }
    bool operator!=(const StyleExplicitSize_Body& other) const {
      return width != other.width ||
             height != other.height;
    }
  };

  Tag tag;
  union {
    StyleExplicitSize_Body explicit_size;
  };

  static StyleGenericBackgroundSize ExplicitSize(const StyleGenericLengthPercentageOrAuto<LengthPercent> &aWidth,
                                                 const StyleGenericLengthPercentageOrAuto<LengthPercent> &aHeight) {
    StyleGenericBackgroundSize result;
    ::new (&result.explicit_size.width) (StyleGenericLengthPercentageOrAuto<LengthPercent>)(aWidth);
    ::new (&result.explicit_size.height) (StyleGenericLengthPercentageOrAuto<LengthPercent>)(aHeight);
    result.tag = Tag::ExplicitSize;
    return result;
  }

  static StyleGenericBackgroundSize Cover() {
    StyleGenericBackgroundSize result;
    result.tag = Tag::Cover;
    return result;
  }

  static StyleGenericBackgroundSize Contain() {
    StyleGenericBackgroundSize result;
    result.tag = Tag::Contain;
    return result;
  }

  bool IsExplicitSize() const {
    return tag == Tag::ExplicitSize;
  }

  bool IsCover() const {
    return tag == Tag::Cover;
  }

  bool IsContain() const {
    return tag == Tag::Contain;
  }

  const StyleExplicitSize_Body& AsExplicitSize() const {
    MOZ_ASSERT(IsExplicitSize());
    return explicit_size;
  }

  bool operator==(const StyleGenericBackgroundSize& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::ExplicitSize: return explicit_size == other.explicit_size;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericBackgroundSize& other) const {
    return !(*this == other);
  }
  bool IsInitialValue() const;
};

/// A computed value for the `background-size` property.
using StyleBackgroundSize = StyleGenericBackgroundSize<StyleNonNegativeLengthPercentage>;

struct StyleNumberOrPercentage {
  enum class Tag : uint8_t {
    Percentage,
    Number,
  };

  struct StylePercentage_Body {
    StylePercentage _0;

    bool operator==(const StylePercentage_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StylePercentage_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleNumber_Body {
    StyleNumber _0;

    bool operator==(const StyleNumber_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleNumber_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StylePercentage_Body percentage;
    StyleNumber_Body number;
  };

  static StyleNumberOrPercentage Percentage(const StylePercentage &a0) {
    StyleNumberOrPercentage result;
    ::new (&result.percentage._0) (StylePercentage)(a0);
    result.tag = Tag::Percentage;
    return result;
  }

  static StyleNumberOrPercentage Number(const StyleNumber &a0) {
    StyleNumberOrPercentage result;
    ::new (&result.number._0) (StyleNumber)(a0);
    result.tag = Tag::Number;
    return result;
  }

  bool IsPercentage() const {
    return tag == Tag::Percentage;
  }

  bool IsNumber() const {
    return tag == Tag::Number;
  }

  const StylePercentage& AsPercentage() const {
    MOZ_ASSERT(IsPercentage());
    return percentage._0;
  }

  const StyleNumber& AsNumber() const {
    MOZ_ASSERT(IsNumber());
    return number._0;
  }

  bool operator==(const StyleNumberOrPercentage& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Percentage: return percentage == other.percentage;
      case Tag::Number: return number == other.number;
      default: return true;
    }
  }

  bool operator!=(const StyleNumberOrPercentage& other) const {
    return !(*this == other);
  }
};

/// A non-negative <number-percentage>.
using StyleNonNegativeNumberOrPercentage = StyleNonNegative<StyleNumberOrPercentage>;

/// A generic value for the `border-image-slice` property.
template<typename NumberOrPercentage>
struct StyleGenericBorderImageSlice {
  /// The offsets.
  StyleRect<NumberOrPercentage> offsets;
  /// Whether to fill the middle part.
  bool fill;

  bool operator==(const StyleGenericBorderImageSlice& other) const {
    return offsets == other.offsets &&
           fill == other.fill;
  }
  bool operator!=(const StyleGenericBorderImageSlice& other) const {
    return offsets != other.offsets ||
           fill != other.fill;
  }
};

/// A computed value for the `border-image-slice` property.
using StyleBorderImageSlice = StyleGenericBorderImageSlice<StyleNonNegativeNumberOrPercentage>;

/// A generic size, for `border-*-radius` longhand properties, or
/// `border-spacing`.
template<typename L>
struct StyleSize2D {
  L width;
  L height;

  bool operator==(const StyleSize2D& other) const {
    return width == other.width &&
           height == other.height;
  }
  bool operator!=(const StyleSize2D& other) const {
    return width != other.width ||
           height != other.height;
  }
};

/// A generic value for the `border-spacing` property.
template<typename L>
using StyleBorderSpacing = StyleSize2D<L>;

/// A generic value for the `border-*-radius` longhand properties.
template<typename L>
struct StyleGenericBorderCornerRadius {
  StyleSize2D<L> _0;

  bool operator==(const StyleGenericBorderCornerRadius& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleGenericBorderCornerRadius& other) const {
    return _0 != other._0;
  }
};

/// A generic value for `border-radius`, `outline-radius` and `inset()`.
/// <https://drafts.csswg.org/css-backgrounds-3/#border-radius>
template<typename LengthPercentage>
struct StyleGenericBorderRadius {
  /// The top left radius.
  StyleGenericBorderCornerRadius<LengthPercentage> top_left;
  /// The top right radius.
  StyleGenericBorderCornerRadius<LengthPercentage> top_right;
  /// The bottom right radius.
  StyleGenericBorderCornerRadius<LengthPercentage> bottom_right;
  /// The bottom left radius.
  StyleGenericBorderCornerRadius<LengthPercentage> bottom_left;

  bool operator==(const StyleGenericBorderRadius& other) const {
    return top_left == other.top_left &&
           top_right == other.top_right &&
           bottom_right == other.bottom_right &&
           bottom_left == other.bottom_left;
  }
  bool operator!=(const StyleGenericBorderRadius& other) const {
    return top_left != other.top_left ||
           top_right != other.top_right ||
           bottom_right != other.bottom_right ||
           bottom_left != other.bottom_left;
  }
  inline const StyleLengthPercentage& Get(mozilla::HalfCorner) const;
};

/// A computed value for the `border-radius` property.
using StyleBorderRadius = StyleGenericBorderRadius<StyleNonNegativeLengthPercentage>;

/// A generic `<length>` | `<number>` value for the `-moz-tab-size` property.
template<typename L, typename N>
struct StyleGenericLengthOrNumber {
  enum class Tag : uint8_t {
    /// A number.
    /// NOTE: Numbers need to be before lengths, in order to parse them
    /// first, since `0` should be a number, not the `0px` length.
    Number,
    /// A length.
    Length,
  };

  struct StyleNumber_Body {
    N _0;

    bool operator==(const StyleNumber_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleNumber_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleLength_Body {
    L _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleNumber_Body number;
    StyleLength_Body length;
  };

  static StyleGenericLengthOrNumber Number(const N &a0) {
    StyleGenericLengthOrNumber result;
    ::new (&result.number._0) (N)(a0);
    result.tag = Tag::Number;
    return result;
  }

  static StyleGenericLengthOrNumber Length(const L &a0) {
    StyleGenericLengthOrNumber result;
    ::new (&result.length._0) (L)(a0);
    result.tag = Tag::Length;
    return result;
  }

  bool IsNumber() const {
    return tag == Tag::Number;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  const N& AsNumber() const {
    MOZ_ASSERT(IsNumber());
    return number._0;
  }

  const L& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericLengthOrNumber& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Number: return number == other.number;
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericLengthOrNumber& other) const {
    return !(*this == other);
  }
};

/// Either a non-negative `<length>` or a `<number>`.
using StyleNonNegativeLengthOrNumber = StyleGenericLengthOrNumber<StyleNonNegativeLength, StyleNonNegativeNumber>;

/// A specified rectangle made of four `<length-or-number>` values.
using StyleNonNegativeLengthOrNumberRect = StyleRect<StyleNonNegativeLengthOrNumber>;

/// A generic value for the `perspective` property.
template<typename NonNegativeLength>
struct StyleGenericPerspective {
  enum class Tag : uint8_t {
    /// A non-negative length.
    Length,
    /// The keyword `none`.
    None,
  };

  struct StyleLength_Body {
    NonNegativeLength _0;

    bool operator==(const StyleLength_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleLength_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleLength_Body length;
  };

  static StyleGenericPerspective Length(const NonNegativeLength &a0) {
    StyleGenericPerspective result;
    ::new (&result.length._0) (NonNegativeLength)(a0);
    result.tag = Tag::Length;
    return result;
  }

  static StyleGenericPerspective None() {
    StyleGenericPerspective result;
    result.tag = Tag::None;
    return result;
  }

  bool IsLength() const {
    return tag == Tag::Length;
  }

  bool IsNone() const {
    return tag == Tag::None;
  }

  const NonNegativeLength& AsLength() const {
    MOZ_ASSERT(IsLength());
    return length._0;
  }

  bool operator==(const StyleGenericPerspective& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Length: return length == other.length;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericPerspective& other) const {
    return !(*this == other);
  }
};

/// A computed value for the `perspective` property.
using StylePerspective = StyleGenericPerspective<StyleNonNegativeLength>;

/// A generic value for the `z-index` property.
template<typename I>
struct StyleGenericZIndex {
  enum class Tag : uint8_t {
    /// An integer value.
    Integer,
    /// The keyword `auto`.
    Auto,
  };

  struct StyleInteger_Body {
    I _0;

    bool operator==(const StyleInteger_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleInteger_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleInteger_Body integer;
  };

  static StyleGenericZIndex Integer(const I &a0) {
    StyleGenericZIndex result;
    ::new (&result.integer._0) (I)(a0);
    result.tag = Tag::Integer;
    return result;
  }

  static StyleGenericZIndex Auto() {
    StyleGenericZIndex result;
    result.tag = Tag::Auto;
    return result;
  }

  bool IsInteger() const {
    return tag == Tag::Integer;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  const I& AsInteger() const {
    MOZ_ASSERT(IsInteger());
    return integer._0;
  }

  bool operator==(const StyleGenericZIndex& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Integer: return integer == other.integer;
      default: return true;
    }
  }

  bool operator!=(const StyleGenericZIndex& other) const {
    return !(*this == other);
  }
};

/// A computed value for the `z-index` property.
using StyleZIndex = StyleGenericZIndex<StyleInteger>;

/// A generic transform origin.
template<typename H, typename V, typename Depth>
struct StyleGenericTransformOrigin {
  /// The horizontal origin.
  H horizontal;
  /// The vertical origin.
  V vertical;
  /// The depth.
  Depth depth;

  bool operator==(const StyleGenericTransformOrigin& other) const {
    return horizontal == other.horizontal &&
           vertical == other.vertical &&
           depth == other.depth;
  }
  bool operator!=(const StyleGenericTransformOrigin& other) const {
    return horizontal != other.horizontal ||
           vertical != other.vertical ||
           depth != other.depth;
  }
};

/// The computed value of a CSS `<transform-origin>`
using StyleTransformOrigin = StyleGenericTransformOrigin<StyleLengthPercentage, StyleLengthPercentage, StyleLength>;

/// Constants for contain: https://drafts.csswg.org/css-contain/#contain-property
struct StyleContain {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleContain operator|(const StyleContain& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleContain& operator|=(const StyleContain& other) {
    *this = (*this | other);
    return *this;
  }
  StyleContain operator&(const StyleContain& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleContain& operator&=(const StyleContain& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleContain& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleContain& other) const {
    return bits != other.bits;
  }
};
static const StyleContain StyleContain_NONE = (StyleContain){ .bits = 0 };
static const StyleContain StyleContain_SIZE = (StyleContain){ .bits = 1 << 0 };
static const StyleContain StyleContain_LAYOUT = (StyleContain){ .bits = 1 << 1 };
static const StyleContain StyleContain_PAINT = (StyleContain){ .bits = 1 << 2 };
static const StyleContain StyleContain_STRICT = (StyleContain){ .bits = 1 << 3 };
static const StyleContain StyleContain_CONTENT = (StyleContain){ .bits = 1 << 4 };

/// The kind of restyle we need to do for a given element.
struct StyleRestyleHint {
  uint8_t bits;

  explicit operator bool() const {
    return !!bits;
  }
  StyleRestyleHint operator|(const StyleRestyleHint& other) const {
    return {static_cast<decltype(bits)>(this->bits | other.bits)};
  }
  StyleRestyleHint& operator|=(const StyleRestyleHint& other) {
    *this = (*this | other);
    return *this;
  }
  StyleRestyleHint operator&(const StyleRestyleHint& other) const {
    return {static_cast<decltype(bits)>(this->bits & other.bits)};
  }
  StyleRestyleHint& operator&=(const StyleRestyleHint& other) {
    *this = (*this & other);
    return *this;
  }
  bool operator==(const StyleRestyleHint& other) const {
    return bits == other.bits;
  }
  bool operator!=(const StyleRestyleHint& other) const {
    return bits != other.bits;
  }
  static inline StyleRestyleHint RestyleSubtree();
  static inline StyleRestyleHint RecascadeSubtree();
  static inline StyleRestyleHint ForAnimations();
};
static const StyleRestyleHint StyleRestyleHint_RESTYLE_SELF = (StyleRestyleHint){ .bits = 1 << 0 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_DESCENDANTS = (StyleRestyleHint){ .bits = 1 << 1 };
static const StyleRestyleHint StyleRestyleHint_RECASCADE_SELF = (StyleRestyleHint){ .bits = 1 << 2 };
static const StyleRestyleHint StyleRestyleHint_RECASCADE_DESCENDANTS = (StyleRestyleHint){ .bits = 1 << 3 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_CSS_TRANSITIONS = (StyleRestyleHint){ .bits = 1 << 4 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_CSS_ANIMATIONS = (StyleRestyleHint){ .bits = 1 << 5 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_STYLE_ATTRIBUTE = (StyleRestyleHint){ .bits = 1 << 6 };
static const StyleRestyleHint StyleRestyleHint_RESTYLE_SMIL = (StyleRestyleHint){ .bits = 1 << 7 };

} // namespace mozilla

#endif // mozilla_ServoStyleConsts_h
